/**********************************************************************/
/*                                                                    */
/*   Licensed Materials - Property of IBM.                            */
/*   5724-T42 5724-T43 5724-T44                                       */
/*   Copyright IBM Corp. and by others 2007.                          */
/*   All Rights Reserved.                                             */
/*   US Government Users Restricted Rights -                          */
/*   Use, duplication or disclosure restricted by                     */
/*   GSA ADP Schedule Contract with IBM Corp.                         */
/*                                                                    */
/**********************************************************************/

#ifndef MASS_ATAN2_H
#define MASS_ATAN2_H1
#include <spu_intrinsics.h>
#ifdef __IBMC__
typedef vector unsigned char arg_t;
#else
typedef vector signed char arg_t;
#endif
static __inline vector float _atan2f4(vector float var1,vector float var2){
    vector float var10;
    vector float var11;
    vector float var12;
    vector float var13;
    vector float var14;
    vector float var15;
    vector float var16;
    vector float var17;
    vector float var18;
    vector float var19;
    vector float var20;
    vector float var21;
    vector float var22;
    vector float var23;
    vector float var24;
    vector float var25;
    vector float var26;
    vector float var27;
    vector float var28;
    vector float var29;
    vector float var3;
    vector float var30;
    vector float var31;
    vector float var32;
    vector float var33;
    vector float var34;
    vector float var35;
    vector float var36;
    vector float var37;
    vector float var38;
    vector float var39;
    vector float var4;
    vector float var40;
    vector float var41;
    vector float var42;
    vector float var43;
    vector float var44;
    vector float var45;
    vector float var46;
    vector float var47;
    vector float var48;
    vector float var49;
    vector float var5;
    vector float var50;
    vector float var51;
    vector float var52;
    vector float var53;
    vector float var54;
    vector float var55;
    vector float var56;
    vector float var6;
    vector float var7;
    vector float var8;
    vector float var9;
    var11=(vector float)(vector unsigned char){0,0,0,8,0,0,0,8,0,0,0,8,0,0,0,8};
    var13=(vector float)(vector unsigned char){15,15,15,15,3,3,3,3,7,7,7,7,11,11,11,11};
    var15=(vector float)(vector unsigned char){12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12};
    var22=(vector float)(vector unsigned char){63,128,0,0,63,128,0,0,63,128,0,0,63,128,0,0};
    var26=(vector float)(vector unsigned char){128,0,0,0,128,0,0,0,128,0,0,0,128,0,0,0};
    var28=(vector float)(vector unsigned char){61,115,79,219,62,8,107,57,62,54,107,131,62,60,148,18};
    var29=(vector float)(vector unsigned char){62,38,51,92,62,2,182,174,61,187,240,104,61,121,52,94};
    var3=(vector float)(vector unsigned char){191,128,0,0,63,128,0,0,63,128,0,0,191,128,0,0};
    var30=(vector float)(vector unsigned char){63,127,255,255,63,127,255,255,63,127,255,255,63,127,255,255};
    var31=(vector float)(vector unsigned char){68,128,0,0,68,128,0,0,68,128,0,0,68,128,0,0};
    var33=(vector float)(vector unsigned char){2,2,2,2,6,6,6,6,10,10,10,10,14,14,14,14};
    var35=(vector float)(vector unsigned char){28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28};
    var38=(vector float)(vector unsigned char){190,173,209,87,190,188,118,140,190,205,57,198,190,208,39,235};
    var39=(vector float)(vector unsigned char){190,191,6,192,190,157,159,42,190,104,149,182,190,21,155,58};
    var4=(vector float)(vector unsigned char){63,128,0,0,191,128,0,0,191,128,0,0,63,128,0,0};
    var42=(vector float)(vector unsigned char){57,132,89,20,59,133,29,158,60,70,22,123,60,99,3,138};
    var43=(vector float)(vector unsigned char){187,85,37,50,189,53,75,122,189,214,193,7,190,51,233,140};
    var46=(vector float)(vector unsigned char){63,127,255,203,63,127,244,104,63,127,200,251,63,127,189,144};
    var47=(vector float)(vector unsigned char){63,128,62,133,63,129,88,132,63,131,73,252,63,133,238,228};
    var50=(vector float)(vector unsigned char){51,128,0,0,51,128,0,0,51,128,0,0,51,128,0,0};
    var53=(vector float)(vector unsigned char){63,201,15,218,63,201,15,218,191,201,15,218,191,201,15,218};
    var54=(vector float)(vector unsigned char){0,0,0,0,64,73,15,218,0,0,0,0,192,73,15,218};
    var6=(vector float)(vector unsigned char){0,1,2,3,0,1,2,3,0,1,2,3,0,1,2,3};
    var7=(vector float)(vector unsigned char){239,239,239,239,239,239,239,239,239,239,239,239,239,239,239,239};
    var10=(vector float)si_rotqbii((arg_t)var1,(int)4);
    var9=(vector float)si_rotqbii((arg_t)var2,(int)3);
    var12=(vector float)si_selb((arg_t)var9,(arg_t)var10,(arg_t)var11);
    var14=(vector float)si_shufb((arg_t)var12,(arg_t)var12,(arg_t)var13);
    var5=(vector float)si_fcmgt((arg_t)var2,(arg_t)var1);
    var19=(vector float)si_selb((arg_t)var1,(arg_t)var2,(arg_t)var5);
    var20=(vector float)si_frest((arg_t)var19);
    var21=(vector float)si_fi((arg_t)var19,(arg_t)var20);
    var23=(vector float)si_fnms((arg_t)var19,(arg_t)var21,(arg_t)var22);
    var24=(vector float)si_fma((arg_t)var23,(arg_t)var21,(arg_t)var21);
    var18=(vector float)si_selb((arg_t)var2,(arg_t)var1,(arg_t)var5);
    var25=(vector float)si_fm((arg_t)var18,(arg_t)var24);
    var27=(vector float)si_andc((arg_t)var25,(arg_t)var26);
    var51=(vector float)si_fm((arg_t)var27,(arg_t)var50);
    var32=(vector float)si_fma((arg_t)var27,(arg_t)var30,(arg_t)var31);
    var34=(vector float)si_shufb((arg_t)var32,(arg_t)var32,(arg_t)var33);
    var36=(vector float)si_selb((arg_t)var6,(arg_t)var34,(arg_t)var35);
    var48=(vector float)si_shufb((arg_t)var46,(arg_t)var47,(arg_t)var36);
    var44=(vector float)si_shufb((arg_t)var42,(arg_t)var43,(arg_t)var36);
    var40=(vector float)si_shufb((arg_t)var38,(arg_t)var39,(arg_t)var36);
    var37=(vector float)si_shufb((arg_t)var28,(arg_t)var29,(arg_t)var36);
    var41=(vector float)si_fma((arg_t)var27,(arg_t)var37,(arg_t)var40);
    var45=(vector float)si_fma((arg_t)var27,(arg_t)var41,(arg_t)var44);
    var49=(vector float)si_fma((arg_t)var27,(arg_t)var45,(arg_t)var48);
    var52=(vector float)si_fma((arg_t)var27,(arg_t)var49,(arg_t)var51);
    var8=(vector float)si_selb((arg_t)var5,(arg_t)var6,(arg_t)var7);
    var16=(vector float)si_selb((arg_t)var8,(arg_t)var14,(arg_t)var15);
    var55=(vector float)si_shufb((arg_t)var53,(arg_t)var54,(arg_t)var16);
    var17=(vector float)si_shufb((arg_t)var3,(arg_t)var4,(arg_t)var16);
    var56=(vector float)si_fma((arg_t)var17,(arg_t)var52,(arg_t)var55);
    return var56;
}

#endif /* MASS_ATAN2_H */
