/**********************************************************************/
/*                                                                    */
/*   Licensed Materials - Property of IBM.                            */
/*   5724-T42 5724-T43 5724-T44                                       */
/*   Copyright IBM Corp. and by others 2007.                          */
/*   All Rights Reserved.                                             */
/*   US Government Users Restricted Rights -                          */
/*   Use, duplication or disclosure restricted by                     */
/*   GSA ADP Schedule Contract with IBM Corp.                         */
/*                                                                    */
/**********************************************************************/

#ifndef MASS_HYPOT_H
#define MASS_HYPOT_H1
#include <spu_intrinsics.h>
#ifdef __IBMC__
typedef vector unsigned char arg_t;
#else
typedef vector signed char arg_t;
#endif
static __inline vector float _hypotf4(vector float var1,vector float var2){
    vector float var10;
    vector float var11;
    vector float var12;
    vector float var13;
    vector float var3;
    vector float var4;
    vector float var5;
    vector float var6;
    vector float var7;
    vector float var8;
    vector float var9;
    var10=(vector float)(vector unsigned char){63,0,0,0,63,0,0,0,63,0,0,0,63,0,0,0};
    var8=(vector float)(vector unsigned char){63,128,0,0,63,128,0,0,63,128,0,0,63,128,0,0};
    var3=(vector float)si_fm((arg_t)var2,(arg_t)var2);
    var4=(vector float)si_fma((arg_t)var1,(arg_t)var1,(arg_t)var3);
    var5=(vector float)si_frsqest((arg_t)var4);
    var6=(vector float)si_fi((arg_t)var4,(arg_t)var5);
    var11=(vector float)si_fm((arg_t)var6,(arg_t)var10);
    var7=(vector float)si_fm((arg_t)var4,(arg_t)var6);
    var9=(vector float)si_fnms((arg_t)var7,(arg_t)var6,(arg_t)var8);
    var12=(vector float)si_fma((arg_t)var9,(arg_t)var11,(arg_t)var6);
    var13=(vector float)si_fm((arg_t)var4,(arg_t)var12);
    return var13;
}

#endif /* MASS_HYPOT_H */
