/**********************************************************************/
/*                                                                    */
/*   Licensed Materials - Property of IBM.                            */
/*   5724-T42 5724-T43 5724-T44                                       */
/*   Copyright IBM Corp. and by others 2007.                          */
/*   All Rights Reserved.                                             */
/*   US Government Users Restricted Rights -                          */
/*   Use, duplication or disclosure restricted by                     */
/*   GSA ADP Schedule Contract with IBM Corp.                         */
/*                                                                    */
/**********************************************************************/

#ifndef MASS_RECIP_H
#define MASS_RECIP_H1
#include <spu_intrinsics.h>
#ifdef __IBMC__
typedef vector unsigned char arg_t;
#else
typedef vector signed char arg_t;
#endif
static __inline vector float _recipf4(vector float var1){
    vector float var2;
    vector float var3;
    vector float var4;
    vector float var5;
    vector float var6;
    var4=(vector float)(vector unsigned char){63,128,0,0,63,128,0,0,63,128,0,0,63,128,0,0};
    var2=(vector float)si_frest((arg_t)var1);
    var3=(vector float)si_fi((arg_t)var1,(arg_t)var2);
    var5=(vector float)si_fnms((arg_t)var1,(arg_t)var3,(arg_t)var4);
    var6=(vector float)si_fma((arg_t)var5,(arg_t)var3,(arg_t)var3);
    return var6;
}

#endif /* MASS_RECIP_H */
